#include <Stepper.h>
#include <LiquidCrystal.h>
#include "Adafruit_VEML7700.h"
int stepsPerRevolution = 2048;
int motSpeed = 10;
Stepper myStepper(stepsPerRevolution, 8, 10, 9, 11);
LiquidCrystal lcd(2, 3, 4, 5, 6, 7);
Adafruit_VEML7700 veml;

int direction = 1;


int look_for_better_sunlight() {
  int lux = veml.readLux();
  float W = 220.0 * lux / 700;
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Bad sunlight");
  lcd.setCursor(0,1);
  lcd.print("Lux: " + String(lux) + " KW: " + String(W));
  int current_steps = 0;
  while (lux < 700) {
    current_steps = 0;
    while(current_steps < stepsPerRevolution/2) {
      int lux_ant = lux;
      myStepper.step(stepsPerRevolution/64);
      current_steps += stepsPerRevolution/64;
      lux = veml.readLux();
      float W = 220.0 * lux / 700;
      lcd.setCursor(0,1);
      lcd.print("Lux: " + String(lux) + " KW: " + String(W));
      if (lux > 700) {
        Serial.println("boss1");
        return 10000;
      }
      if(lux < lux_ant) {
        break;
      }
      delay(100);
    }
    while (current_steps > -stepsPerRevolution/2) {
      int lux_ant = lux;
      myStepper.step(-stepsPerRevolution/64);
      current_steps -= stepsPerRevolution/64;
      lux = veml.readLux();
      float W = 220.0 * lux / 700;
      lcd.setCursor(0,1);
      lcd.print("Lux: " + String(lux) + " KW: " + String(W));
      if (lux > 700) {
        Serial.println("boss2");
        return 10000;
      }
      if (lux < lux_ant) {
        break;
      }
      delay(100);
    }
  }
  
}

void setup() {
  // put your setup code here, to run once:
  Serial.begin(9600);
  myStepper.setSpeed(motSpeed);
  lcd.begin(16,2);
  if (veml.begin()) {
    Serial.println("Found a VEML7700 sensor");
  } else {
    Serial.println("No sensor found ... check your wiring?");
    while (1);
  }
  veml.setGain(VEML7700_GAIN_1);
  veml.setIntegrationTime(VEML7700_IT_100MS);
  
}

void loop() {
  int code = look_for_better_sunlight();
  if(code == 10000) {
    lcd.clear();
    int lux = veml.readLux();
    while(lux > 700) {
      lux = veml.readLux();
      float W = 220.0 * lux / 700;
      lcd.clear();
      lcd.setCursor(0,0);
      lcd.print("Lux: " + String(lux) + " KW: " + String(W));
      lcd.setCursor(0,1);
      lcd.print("Sunlight is good");
    }
    
  }
  

}
